=== debian/changelog ===
nextpnr (0.1-1) unstable; urgency=medium

  * Fix Vcs-Git typo
  * Switch upstream to git tags
  * New upstream version 0.1

 -- Daniel Gröber <dxld@darkboxed.org>  Tue, 11 Jan 2022 18:43:33 +0100
