=== debian/control ===
Source: nextpnr
Maintainer: Debian Electronics Team <pkg-electronics-devel@lists.alioth.debian.org>
Uploaders: Ruben Undheim <ruben.undheim@gmail.com>,
           Nathaniel Graff <nathaniel.graff@sifive.com>
Section: electronics
Priority: optional
Build-Depends: debhelper-compat (= 13),
               cmake,
               qtbase5-dev,
               libboost-filesystem-dev,
               libboost-thread-dev,
               libboost-program-options-dev,
               libboost-python-dev,
               libboost-iostreams-dev,
               libqt5opengl5-dev,
               libeigen3-dev,
               python3-dev,
               fpga-icestorm-chipdb (>= 0~20180809git7e73288-2),
               help2man
Standards-Version: 4.6.0
Vcs-Browser: https://salsa.debian.org/electronics-team/nextpnr
Vcs-Git: https://salsa.debian.org/electronics-team/nextpnr.git
Homepage: https://github.com/YosysHQ/nextpnr
Rules-Requires-Root: no

Package: nextpnr-ice40
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Suggests: yosys, fpga-icestorm
Conflicts: nextpnr-ice40-qt
Replaces: nextpnr-ice40-qt
Description: FPGA place and route tool for Lattice iCE40
 nextpnr aims to be a vendor neutral, timing driven, FOSS FPGA place and route
 tool.
 .
 nextpnr-ice40 is to be used for Lattice iCE40 FPGAs and uses fpga-icestorm to
 achieve that.
 .
 This package can perform place-and-route for Lattice iCE40 devices
 and contains only the command-line functionality. For the QT GUI,
 see nextpnr-ice40-qt.

Package: nextpnr-ice40-qt
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Suggests: yosys, fpga-icestorm
Conflicts: nextpnr-ice40
Replaces: nextpnr-ice40
Description: FPGA place and route tool for Lattice iCE40 - with GUI
 nextpnr aims to be a vendor neutral, timing driven, FOSS FPGA place and route
 tool.
 .
 nextpnr-ice40 is to be used for Lattice iCE40 FPGAs and uses fpga-icestorm to
 achieve that.
 .
 This package can perform place-and-route for Lattice iCE40 devices
 and includes the QT GUI.

Package: nextpnr-generic
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Place and route tool for Generic FPGAs
 nextpnr aims to be a vendor neutral, timing driven, FOSS FPGA place and route
 tool.
 .
 nextpnr-generic allows running placement and routing for arbitrary custom
 architectures. It is more experimental than nextpnr-ice40.
