=== debian/changelog ===
nextpnr (0.3-2) unstable; urgency=medium

  * Team upload.
  * Added ref to paper
  * Extended package description [Steffen & Daniel].
  * Standards-Version: 4.6.1

 -- Steffen Moeller <moeller@debian.org>  Sun, 03 Jul 2022 14:09:34 +0200

nextpnr (0.3-1) unstable; urgency=medium

  * Team upload.

  [ Daniel Gröber ]
  * New upstream version 0.2

  [ Pino Toscano ]
  * Directly install in the destination directories
  * Properly use the dh_auto_* helpers
  * Set BUILDDIR to debian/build

  [ Daniel Gröber ]
  * Mark tests as superficial

 -- Daniel Gröber <dxld@darkboxed.org>  Sun, 27 Mar 2022 19:09:39 +0200
